import create from 'dd-store'
import exampleStore from '/stores/exampleStore'
import { deleteSchedule, modifySchedule, addSchedule, getUserScheduleInTime, getHomeUserSchedule, getScheduleDetail } from '../../api/request.js'
import { stringify } from 'querystring';
create.Page({
  store: exampleStore,
  useAll: true,
  data: {
    timeStaus: '',
    isShowModal: false,
    title: null,
    time1: '',
    week1: '',
    time2: '',
    week2: '',
    propsTime: '',
    weekList: ['周日', '周一', '周二', '周三', '周四', '周五', '周六'],
    id: '', // 日程ID 从详情页面传过来
    buttonText: '立即创建'
  },
  onLoad(event) {
    this.store.data.remark = ''
    this.store.data.aheadTimes = []
    this.store.data.recurrenceModel = {
      model: "no_repeat"
    }
    this.store.data.conflictPeople = []
    this.store.data.participatorList = []
    this.store.data.locationName = ''
    this.store.data.participatorUserId = [getApp().globalData.userid]
    this.update()
    dd.setNavigationBar({
      title: '创建会议'
    })
    var date = new Date();
    var y = date.getFullYear();
    var m = (date.getMonth() + 1) < 10 ? "0" + (date.getMonth() + 1) : (date.getMonth() + 1);//获取当前月份的日期，不足10补0
    var d = date.getDate() < 10 ? "0" + date.getDate() : date.getDate();//获取当前几号，不足10补0
    var weekList = this.data.weekList
    var w = weekList[date.getDay()];
    var h = date.getHours()
    var min = date.getMinutes();
    this.setData({
      time1: `${y}/${m}/${d} ${h < 10 ? "0" + date.getHours() : date.getHours()}:${min < 30 ? '00' : '30'}`,
      time2: `${y}/${m}/${d} ${min < 30 ? h < 10 ? "0" + date.getHours() : date.getHours() : (h + 1) < 10 ? "0" + (date.getHours() + 1) : date.getHours() + 1}:${min < 30 ? '30' : '00'}`,
      week1: w,
      week2: w,
      type: event.type,
      id: event.id
    })
    if (!!event.id) {
      this.getScheduleInfo()
      dd.setNavigationBar({
        title: '编辑会议'
      })
      this.setData({
        buttonText: '保存编辑'
      })
    }
  },
  onShow() {
    const _that = this
    setTimeout(function () {
      _that.update()

    }, 100)
  },
  // 选择时间
  selectTime(event) {
    this.setData({
      timeStaus: event.target.dataset.timeStaus,
      isShowModal: true,
      propsTime: event.target.dataset.timeStaus == 0 ? this.data.time1 : this.data.time2
    })
  },
  // 选择时间组件回调
  changeSelectTime(e) {
    if (e.status === 1) {

      var date1 = new Date(e.time);
      var weekList = ['周日', '周一', '周二', '周三', '周四', '周五', '周六']
      var w1 = weekList[date1.getDay()];
      if (this.data.timeStaus == 0) {
        if (new Date(e.time).getTime() > new Date(this.data.time2).getTime()) {
          var date = new Date(e.time);
          date.setMinutes(date.getMinutes() + 30)
          var y = date.getFullYear();
          var m = (date.getMonth() + 1) < 10 ? "0" + (date.getMonth() + 1) : (date.getMonth() + 1);//获取当前月份的日期，不足10补0
          var d = date.getDate() < 10 ? "0" + date.getDate() : date.getDate();//获取当前几号，不足10补0
          var w2 = weekList[date.getDay()];
          var h = date.getHours()
          var min = date.getMinutes();
          this.setData({
            time1: e.time,
            time2: `${y}/${m}/${d} ${h < 10 ? "0" + date.getHours() : date.getHours()}:${min < 10 ? "0" + min : min}`,
            isShowModal: false,
            week1: w1,
            week2: w2
          })
          this.conflict()

        } else {
          this.setData({
            time1: e.time,
            isShowModal: false,
            week1: w1
          })
          this.conflict()
        }
      } else {
        if (new Date(e.time).getTime() < new Date(this.data.time1).getTime()) {
          dd.alert({
            title: '提示',
            content: '会议结束时间不能小于开始时间',
            buttonText: '我知道了',
            success: () => {
            },
          });
        } else {
          this.setData({
            time2: e.time,
            isShowModal: false,
            week2: w1
          })
          this.conflict()
        }
      }
    } else {
      this.setData({
        isShowModal: false
      })
    }
  },
  // input 输入事件
  getTitle(event) {
    this.setData({
      title: event.detail.value
    })
  },
  // 添加参会人
  addParticipants() {
    const _that = this
    dd.complexChoose({
      title: "选择参会人",            //标题
      multiple: true,            //是否多选
      limitTips: "超出了",          //超过限定人数返回提示
      maxUsers: 1000,            //最大可选人数
      pickedUsers: _that.store.data.participatorUserId,            //已选用户
      requiredUsers: [],            //必选用户（不可取消选中状态）
      requiredDepartments: [],        //必选部门（不可取消选中状态）
      permissionType: "xxx",          //可添加权限校验，选人权限，目前只有GLOBAL这个参数
      responseUserOnly: true,        //返回人，或者返回人和部门
      success: function (res) {
        res.users.forEach((item, index) => {
          _that.store.data.participatorList.push({ userId: item.userId, username: item.name, headUrl: item.headUrl })
          _that.store.data.participatorUserId.push(item.userId)
        })
        _that.store.data.participatorList = _that.setArrary(_that.store.data.participatorList)
        _that.store.data.participatorUserId = [...new Set(_that.store.data.participatorUserId)]
        _that.update()
        _that.conflict()
      },
      fail: function (err) {

      }
    })
  },
  // 跳转下一页
  nextPage(event) {
    let time = {
      time1: this.data.time1,
      time2: this.data.time2
    }
    switch (event.target.dataset.nextPage) {
      case 'participantsDetail':
        dd.navigateTo({ url: `./../participantsDetail/participantsDetail?time=${JSON.stringify(time)}` })
        break;
      case 'place':
        dd.navigateTo({ url: './../place/place' })
        break;
    }
  },
  // 数组去重
  setArrary(arr, userId) {
    let containt = {}
    for (let x of arr) {
      containt['id' + x.userId] = x
    }
    return Object.values(containt)
  },
  // 保存
  saveCreate() {
    if (!!this.data.id) {
      let data = {
        modifyModel: 'only',
        title: this.data.title || '无主题',
        scheduleId: this.data.id,
        location: {
          longitude: '10',
          latitude: '10',
          locationName: this.store.data.locationName || ''
        },
        startTime: `${this.data.time1.replace(/\//g, "-")}:00`,
        endTime: `${this.data.time2.replace(/\//g, '-')}:00`,
        scheduleType: 'common',
        noticeType: 'dd_notice',
        participatorList: this.store.data.participatorList,
        repeatable: this.store.data.repeatable,
        aheadTimes: this.store.data.aheadTimes,
        recurrenceModel: this.store.data.recurrenceModel,
        meetingRoomId: 222 || null,
        remark: this.store.data.remark
      }
      modifySchedule(data).then(res => {
        dd.redirectTo({
          url: '/pages/index/index'
        })
      })

    } else {
      let data = {
        title: this.data.title || '无主题',
        location: {
          longitude: '10',
          latitude: '10',
          locationName: this.store.data.locationName || ''
        },
        startTime: `${this.data.time1.replace(/\//g, "-")}:00`,
        endTime: `${this.data.time2.replace(/\//g, '-')}:00`,
        scheduleType: 'common',
        noticeType: 'dd_notice',
        participatorList: this.store.data.participatorList,
        repeatable: this.store.data.repeatable,
        aheadTimes: this.store.data.aheadTimes,
        recurrenceModel: this.store.data.recurrenceModel,
        meetingRoomId: 222 || null
      }
      addSchedule(data).then(res => {
        dd.navigateBack({
          delta: 1
        })
      })

    }


  },
  // 关闭编辑项
  closeEditList(event) {
    switch (event.target.dataset.icon) {
      case 'iconchongfu':
        this.store.data.repeatable = 0
        this.store.data.recurrenceModel = {
          model: "no_repeat"
        }
        break;
      case 'icondidianmiaoshu':
        this.store.data.remark = null
        break;
      case 'iconhuiqiantixing':
        this.store.data.aheadTimes = []
        break;
      case 'icondingwei':
        this.store.data.locationName = null
        break;
    }
    // this.store.data.place = ""
    this.update()
  },
  // 会议冲突
  conflict() {
    this.store.data.conflictPeople = []
    let data = {
      startTime: `${this.data.time1.replace(/\//g, "-")}:00`,
      endTime: `${this.data.time2.replace(/\//g, "-")}:00`,
      userIds: this.store.data.participatorUserId
    }
    getUserScheduleInTime(data).then(res => {
      for (let value in res.data.data) {
        if (!!res.data.data[value].length) {
          this.store.data.conflictPeople.push(value)
        }
      }
      this.update()
    })
  },
  // 编辑时获取详情页内容
  getScheduleInfo() {
    let data = {
      id: this.data.id
    }
    getScheduleDetail(data).then(res => {
      console.log(res.data.data.title)
      let participatorUserId = []
      let participatorList = []
      res.data.data.userList.forEach((item, index) => {
        participatorUserId.push(item.participator.userId)
        participatorList.push(item.participator)
      })
      this.store.data.locationName = res.data.data.location.locationName
      this.store.data.participatorUserId = participatorUserId
      this.store.data.participatorList = participatorList
      this.store.data.remark = res.data.data.remark
      this.store.data.recurrenceModel = res.data.data.recurrenceModel

      this.setData({
        title: res.data.data.title,
        time1: res.data.data.startTime.substring(0, 16),
        time2: res.data.data.endTime.substring(0, 16),
        week1: this.data.weekList[new Date(res.data.data.startTime).getDay()],
        week2: this.data.weekList[new Date(res.data.data.endTime).getDay()],
        aheadTimes: res.data.data.aheadTimes,
        // describe: res.data.data.describe,
      })
      this.update()
      this.conflict()
    })
  },
  // 编辑日程
  editSchedule(event) {
    switch (event.target.dataset.icon) {
      case 'iconchongfu':
        dd.navigateTo({ url: `./../repeatMechanism/repeatMechanism` })
        break;
      case 'icondidianmiaoshu':
        dd.navigateTo({ url: './../addRemark/addRemark' })
        break;
      case 'iconhuiqiantixing':
        dd.navigateTo({ url: './../remind/remind' })
        break;
      case 'icondingwei':
        dd.navigateTo({ url: './../place/place' })
        break;
      case 'iconshanchu':
        let data = {
          scheduleId: this.data.id,
          identify: 'major',
          deleteModel: 'only'
        }
        deleteSchedule(data).then(res => {
          dd.redirectTo({
            url: '/pages/index/index'
          })
        })
        break;
    }

  },
  // 选择终止时间
  selectTerminal() {
    let time2 = this.data.time2
    dd.datePicker({
      format: 'yyyy-MM-dd',
      currentDate: '',
      success: (res) => {
        this.store.data.recurrenceModel.terminateTime = `${res.date} `
        this.update()
      },
      error: (err) => {
        console.log(JSON.stringify(err))
      }
    })
  },
  // 获取N年后的日

});
